# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: unacast/catalog/v1/catalog.proto, unacast/catalog/v1/catalog_service.proto, unacast/catalog/v1/data_delivery.proto, unacast/catalog/v1/file_download_service.proto, unacast/catalog/v1/query_service.proto
# plugin: python-betterproto
from dataclasses import dataclass
from typing import (
    TYPE_CHECKING,
    Dict,
    List,
    Optional,
)

import betterproto
import grpclib
from betterproto.grpc.grpclib_server import ServiceBase

from ... import unatype as __unatype__
from ...maps import v1 as __maps_v1__
from ...metric import v1 as __metric_v1__


if TYPE_CHECKING:
    import grpclib.server
    from betterproto.grpc.grpclib_client import MetadataLike
    from grpclib.metadata import Deadline


class DestinationConfigType(betterproto.Enum):
    BIG_QUERY = 0
    GCS = 1
    S3 = 2
    AZURE = 3


class DataDeliveryStatusType(betterproto.Enum):
    ENABLED = 0
    DISABLED = 1


@dataclass(eq=False, repr=False)
class BigQueryDestination(betterproto.Message):
    project_id: str = betterproto.string_field(1)
    dataset_id: str = betterproto.string_field(2)
    table_id: str = betterproto.string_field(3)


@dataclass(eq=False, repr=False)
class FileConfig(betterproto.Message):
    filename: str = betterproto.string_field(1)
    format: str = betterproto.string_field(2)
    compression: str = betterproto.string_field(3)
    field_delimiter: str = betterproto.string_field(4)
    header: bool = betterproto.bool_field(5)


@dataclass(eq=False, repr=False)
class GcsDestination(betterproto.Message):
    bucket: str = betterproto.string_field(1)
    path: str = betterproto.string_field(2)
    region: str = betterproto.string_field(3)


@dataclass(eq=False, repr=False)
class S3Destination(betterproto.Message):
    bucket: str = betterproto.string_field(1)
    path: str = betterproto.string_field(2)
    region: str = betterproto.string_field(3)
    access_key: str = betterproto.string_field(4)
    secret_key: str = betterproto.string_field(5)


@dataclass(eq=False, repr=False)
class AzureDestination(betterproto.Message):
    blob_access_url: str = betterproto.string_field(1)
    container_name: str = betterproto.string_field(2)
    path: str = betterproto.string_field(3)


@dataclass(eq=False, repr=False)
class FileDestination(betterproto.Message):
    file_config: "FileConfig" = betterproto.message_field(2)
    s3_destination: "S3Destination" = betterproto.message_field(
        5, group="bucket_config"
    )
    gcs_destination: "GcsDestination" = betterproto.message_field(
        6, group="bucket_config"
    )
    azure_destination: "AzureDestination" = betterproto.message_field(
        7, group="bucket_config"
    )


@dataclass(eq=False, repr=False)
class DataDeliveryFilters(betterproto.Message):
    feature_filter: List[str] = betterproto.string_field(1)
    """List of features by ID to limit the delivery to"""

    related_feature_filter: List[str] = betterproto.string_field(6)
    """List of related features by ID to limit the delivery to"""

    address_component_filter: List["__maps_v1__.AddressComponentFilter"] = (
        betterproto.message_field(2)
    )
    """
    Filter clause to limit the delivery to certain Address Component Values.
    """

    related_address_component_filter: List["__maps_v1__.AddressComponentFilter"] = (
        betterproto.message_field(7)
    )
    """
    Filter clause to limit the delivery to certain related Address Component
    Values.
    """

    dimension_filter: List["__metric_v1__.DimensionFilter"] = betterproto.message_field(
        3
    )
    """Filter clause to limit the delivery to certain Dimension Values."""

    start_date: "__unatype__.Date" = betterproto.message_field(4)
    """Date from which the delivery will be started"""

    end_date: "__unatype__.Date" = betterproto.message_field(5)
    """
    TODO turn into an optional field once it is supported by proto-gen-validate
    https://github.com/envoyproxy/protoc-gen-validate/issues/431 Optional end
    date of the delivery, if not set (all zeros), it will be continuously
    delivered ad infinitum The date can be in the future, meaning the delivery
    will be updated until that end_date
    """


@dataclass(eq=False, repr=False)
class SearchMetricValuesRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    metric_id: str = betterproto.string_field(2)
    billing_context: str = betterproto.string_field(3)
    track_total_hits_boolean: bool = betterproto.bool_field(4, group="track_total_hits")
    track_total_hits_integer: int = betterproto.int64_field(
        12, group="track_total_hits"
    )
    best_effort_query_when_not_allowed: bool = betterproto.bool_field(11)
    """
    If true, the query will be executed even if the user filters on items it is
    not allowed to see
    """

    invert_sort_order: bool = betterproto.bool_field(9)
    """
    Temporary fix to get random feature IDs, if this view sticks this should be
    extracted into a separate API
    """

    feature_filter: List[str] = betterproto.string_field(5)
    """List of features by ID to limit the search to"""

    related_feature_filter: List[str] = betterproto.string_field(16)
    """List of related-features by ID to limit the search to"""

    observation_period_filter: "__metric_v1__.Period" = betterproto.message_field(6)
    """Filter clause to limit the time period of the search"""

    address_component_filter: List["__maps_v1__.AddressComponentFilter"] = (
        betterproto.message_field(7)
    )
    """
    Filter clause to limit the search to certain Address Component Values.
    """

    related_address_component_filter: List["__maps_v1__.AddressComponentFilter"] = (
        betterproto.message_field(10)
    )
    """
    Filter clause to limit the search to certain related Address Component
    Values.
    """

    dimension_filter: List["__metric_v1__.DimensionFilter"] = betterproto.message_field(
        8
    )
    """Filter clause to limit the search to certain Dimension Values."""

    value_filter: List["__metric_v1__.ValueFilter"] = betterproto.message_field(17)
    """
    Filter clause to limit the search to certain Metric Values which have
    Numeric Value Kind(COUNT; NUMBER).
    """

    request_tags: Dict[str, str] = betterproto.map_field(
        13, betterproto.TYPE_STRING, betterproto.TYPE_STRING
    )
    page_size: int = betterproto.int32_field(14)
    page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class SearchMetricValuesResponse(betterproto.Message):
    values: List["__metric_v1__.MetricValue"] = betterproto.message_field(1)
    applied_filters: "QueryMetricFilters" = betterproto.message_field(2)
    """All the filters applied to the request"""

    total_size: int = betterproto.int32_field(14)
    next_page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class SearchLayerFeaturesRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    layer_id: str = betterproto.string_field(2)
    billing_context: str = betterproto.string_field(3)
    feature_filter: List[str] = betterproto.string_field(5)
    """List of features by ID to limit the search to"""

    address_component_filter: List["__maps_v1__.AddressComponentFilter"] = (
        betterproto.message_field(7)
    )
    """
    Filter clause to limit the search to certain Address Component Values.
    """

    bounding_box_filter: "SearchFeatureBoundingBox" = betterproto.message_field(8)
    """
    If the bounding box is set, only return Features that falls within or
    intersects the bounding box
    """

    query: str = betterproto.string_field(9)
    """
    free text search query. This only sorts by relevance, and does not filter
    out any results. Setting this works in combination with filters. The query
    has fuzziness with edit-distance of 2 per word and splits on whitespace.
    The query is against address component display_names, and short_names.
    """

    track_total_hits: bool = betterproto.bool_field(10)
    page_size: int = betterproto.int32_field(14)
    page_token: str = betterproto.string_field(15)
    existed_in_date_range: "DateRange" = betterproto.message_field(16)


@dataclass(eq=False, repr=False)
class DateRange(betterproto.Message):
    start_date: str = betterproto.string_field(1)
    end_date: str = betterproto.string_field(2)


@dataclass(eq=False, repr=False)
class SearchFeatureBoundingBox(betterproto.Message):
    """
    BoundingBox describes a square geofence - ie the "display area" of a map.
    Values are lat/lon (degrees)
    """

    west: float = betterproto.double_field(1)
    north: float = betterproto.double_field(2)
    east: float = betterproto.double_field(3)
    south: float = betterproto.double_field(4)


@dataclass(eq=False, repr=False)
class SearchLayerFeaturesResponse(betterproto.Message):
    features: List["__maps_v1__.Feature"] = betterproto.message_field(1)
    query_scores: List[float] = betterproto.float_field(10)
    """
    the score for each resulting record, zeros if not applicable higher score
    means higher relevance order is same as features, so match on index. e.g.
    features[0] has score[0]
    """

    total_size: int = betterproto.int32_field(14)
    next_page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class SearchAddressComponentValuesRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    component: str = betterproto.string_field(3)
    query: str = betterproto.string_field(5)
    value_ids: List[str] = betterproto.string_field(6)
    page_size: int = betterproto.int32_field(14)
    page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class SearchAddressComponentValuesResponse(betterproto.Message):
    address_component_values: List["__maps_v1__.AddressComponentValue"] = (
        betterproto.message_field(1)
    )
    total_size: int = betterproto.int32_field(14)
    next_page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class SearchMetricReportRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    metric_id: str = betterproto.string_field(2)
    billing_context: str = betterproto.string_field(3)


@dataclass(eq=False, repr=False)
class QueryMetricFilters(betterproto.Message):
    period_filters: List["__metric_v1__.Period"] = betterproto.message_field(1)
    dimension_filters: List["__metric_v1__.DimensionFilter"] = (
        betterproto.message_field(2)
    )
    address_component_filters: List["__maps_v1__.AddressComponentFilter"] = (
        betterproto.message_field(3)
    )
    related_address_component_filters: List["__maps_v1__.AddressComponentFilter"] = (
        betterproto.message_field(7)
    )
    feature_filters: List[str] = betterproto.string_field(4)
    related_feature_filters: List[str] = betterproto.string_field(5)
    value_filters: List["__metric_v1__.ValueFilter"] = betterproto.message_field(6)


@dataclass(eq=False, repr=False)
class SearchMetricReportResponse(betterproto.Message):
    report: "__metric_v1__.MetricReport" = betterproto.message_field(1)
    applied_filters: "QueryMetricFilters" = betterproto.message_field(2)
    """All the filters applied to the request"""


@dataclass(eq=False, repr=False)
class SearchDimensionValuesRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    dimension_id: str = betterproto.string_field(2)
    query: str = betterproto.string_field(5)
    page_size: int = betterproto.int32_field(14)
    page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class SearchDimensionValuesResponse(betterproto.Message):
    dimension_values: List["__metric_v1__.DimensionValue"] = betterproto.message_field(
        1
    )
    total_size: int = betterproto.int32_field(14)
    next_page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class Catalog(betterproto.Message):
    id: str = betterproto.string_field(1)


@dataclass(eq=False, repr=False)
class GetCatalogRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)


@dataclass(eq=False, repr=False)
class ListCatalogsRequest(betterproto.Message):
    pass


@dataclass(eq=False, repr=False)
class ListCatalogsResponse(betterproto.Message):
    catalogs: List["Catalog"] = betterproto.message_field(1)


@dataclass(eq=False, repr=False)
class GetMetricRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    metric_id: str = betterproto.string_field(2)
    billing_context: str = betterproto.string_field(3)


@dataclass(eq=False, repr=False)
class GetMetricResponse(betterproto.Message):
    metric: "__metric_v1__.Metric" = betterproto.message_field(1)
    complete_observation_period: "__metric_v1__.Period" = betterproto.message_field(2)


@dataclass(eq=False, repr=False)
class ListMetricsRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    billing_context: str = betterproto.string_field(2)
    layer_filter: List[str] = betterproto.string_field(5)
    availability_filter: List["__unatype__.AvailabilityKind"] = betterproto.enum_field(
        6
    )
    page_size: int = betterproto.int32_field(14)
    page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class ListMetricsResponse(betterproto.Message):
    metrics: List["__metric_v1__.Metric"] = betterproto.message_field(1)
    next_page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class GetLayerRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    layer_id: str = betterproto.string_field(2)


@dataclass(eq=False, repr=False)
class GetLayerResponse(betterproto.Message):
    layer: "__maps_v1__.Layer" = betterproto.message_field(1)


@dataclass(eq=False, repr=False)
class QueryLayerRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    layer_id: str = betterproto.string_field(2)
    address_component_filter: List["__maps_v1__.AddressComponentFilter"] = (
        betterproto.message_field(5)
    )
    page_size: int = betterproto.int32_field(14)
    page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class QueryLayerResponse(betterproto.Message):
    features: List["__maps_v1__.Feature"] = betterproto.message_field(4)
    total_size: int = betterproto.int32_field(14)
    next_page_token: str = betterproto.string_field(15)


@dataclass(eq=False, repr=False)
class DownloadMetricRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    metric_id: str = betterproto.string_field(2)
    billing_context: str = betterproto.string_field(3)
    file_name: str = betterproto.string_field(6)
    expiry_in_hours: int = betterproto.int64_field(10)


@dataclass(eq=False, repr=False)
class DownloadResponse(betterproto.Message):
    download_id: str = betterproto.string_field(1)
    file_urls: List[str] = betterproto.string_field(2)
    expires_at: str = betterproto.string_field(10)


class QueryServiceStub(betterproto.ServiceStub):
    async def search_metric_values(
        self,
        search_metric_values_request: "SearchMetricValuesRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "SearchMetricValuesResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.QueryService/SearchMetricValues",
            search_metric_values_request,
            SearchMetricValuesResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def search_layer_features(
        self,
        search_layer_features_request: "SearchLayerFeaturesRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "SearchLayerFeaturesResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.QueryService/SearchLayerFeatures",
            search_layer_features_request,
            SearchLayerFeaturesResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def search_address_component_values(
        self,
        search_address_component_values_request: "SearchAddressComponentValuesRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "SearchAddressComponentValuesResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.QueryService/SearchAddressComponentValues",
            search_address_component_values_request,
            SearchAddressComponentValuesResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def search_dimension_values(
        self,
        search_dimension_values_request: "SearchDimensionValuesRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "SearchDimensionValuesResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.QueryService/SearchDimensionValues",
            search_dimension_values_request,
            SearchDimensionValuesResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def search_metric_report(
        self,
        search_metric_report_request: "SearchMetricReportRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "SearchMetricReportResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.QueryService/SearchMetricReport",
            search_metric_report_request,
            SearchMetricReportResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )


class CatalogServiceStub(betterproto.ServiceStub):
    async def list_catalogs(
        self,
        list_catalogs_request: "ListCatalogsRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "ListCatalogsResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.CatalogService/ListCatalogs",
            list_catalogs_request,
            ListCatalogsResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def get_metric(
        self,
        get_metric_request: "GetMetricRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "GetMetricResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.CatalogService/GetMetric",
            get_metric_request,
            GetMetricResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def list_metrics(
        self,
        list_metrics_request: "ListMetricsRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "ListMetricsResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.CatalogService/ListMetrics",
            list_metrics_request,
            ListMetricsResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def get_layer(
        self,
        get_layer_request: "GetLayerRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "GetLayerResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.CatalogService/GetLayer",
            get_layer_request,
            GetLayerResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def query_layer(
        self,
        query_layer_request: "QueryLayerRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "QueryLayerResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.CatalogService/QueryLayer",
            query_layer_request,
            QueryLayerResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )


class FileDownloadServiceStub(betterproto.ServiceStub):
    async def download_metric(
        self,
        download_metric_request: "DownloadMetricRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "DownloadResponse":
        return await self._unary_unary(
            "/unacast.catalog.v1.FileDownloadService/DownloadMetric",
            download_metric_request,
            DownloadResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )


class QueryServiceBase(ServiceBase):
    async def search_metric_values(
        self, search_metric_values_request: "SearchMetricValuesRequest"
    ) -> "SearchMetricValuesResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def search_layer_features(
        self, search_layer_features_request: "SearchLayerFeaturesRequest"
    ) -> "SearchLayerFeaturesResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def search_address_component_values(
        self,
        search_address_component_values_request: "SearchAddressComponentValuesRequest",
    ) -> "SearchAddressComponentValuesResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def search_dimension_values(
        self, search_dimension_values_request: "SearchDimensionValuesRequest"
    ) -> "SearchDimensionValuesResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def search_metric_report(
        self, search_metric_report_request: "SearchMetricReportRequest"
    ) -> "SearchMetricReportResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def __rpc_search_metric_values(
        self,
        stream: "grpclib.server.Stream[SearchMetricValuesRequest, SearchMetricValuesResponse]",
    ) -> None:
        request = await stream.recv_message()
        response = await self.search_metric_values(request)
        await stream.send_message(response)

    async def __rpc_search_layer_features(
        self,
        stream: "grpclib.server.Stream[SearchLayerFeaturesRequest, SearchLayerFeaturesResponse]",
    ) -> None:
        request = await stream.recv_message()
        response = await self.search_layer_features(request)
        await stream.send_message(response)

    async def __rpc_search_address_component_values(
        self,
        stream: "grpclib.server.Stream[SearchAddressComponentValuesRequest, SearchAddressComponentValuesResponse]",
    ) -> None:
        request = await stream.recv_message()
        response = await self.search_address_component_values(request)
        await stream.send_message(response)

    async def __rpc_search_dimension_values(
        self,
        stream: "grpclib.server.Stream[SearchDimensionValuesRequest, SearchDimensionValuesResponse]",
    ) -> None:
        request = await stream.recv_message()
        response = await self.search_dimension_values(request)
        await stream.send_message(response)

    async def __rpc_search_metric_report(
        self,
        stream: "grpclib.server.Stream[SearchMetricReportRequest, SearchMetricReportResponse]",
    ) -> None:
        request = await stream.recv_message()
        response = await self.search_metric_report(request)
        await stream.send_message(response)

    def __mapping__(self) -> Dict[str, grpclib.const.Handler]:
        return {
            "/unacast.catalog.v1.QueryService/SearchMetricValues": (
                grpclib.const.Handler(
                    self.__rpc_search_metric_values,
                    grpclib.const.Cardinality.UNARY_UNARY,
                    SearchMetricValuesRequest,
                    SearchMetricValuesResponse,
                )
            ),
            "/unacast.catalog.v1.QueryService/SearchLayerFeatures": (
                grpclib.const.Handler(
                    self.__rpc_search_layer_features,
                    grpclib.const.Cardinality.UNARY_UNARY,
                    SearchLayerFeaturesRequest,
                    SearchLayerFeaturesResponse,
                )
            ),
            "/unacast.catalog.v1.QueryService/SearchAddressComponentValues": (
                grpclib.const.Handler(
                    self.__rpc_search_address_component_values,
                    grpclib.const.Cardinality.UNARY_UNARY,
                    SearchAddressComponentValuesRequest,
                    SearchAddressComponentValuesResponse,
                )
            ),
            "/unacast.catalog.v1.QueryService/SearchDimensionValues": (
                grpclib.const.Handler(
                    self.__rpc_search_dimension_values,
                    grpclib.const.Cardinality.UNARY_UNARY,
                    SearchDimensionValuesRequest,
                    SearchDimensionValuesResponse,
                )
            ),
            "/unacast.catalog.v1.QueryService/SearchMetricReport": (
                grpclib.const.Handler(
                    self.__rpc_search_metric_report,
                    grpclib.const.Cardinality.UNARY_UNARY,
                    SearchMetricReportRequest,
                    SearchMetricReportResponse,
                )
            ),
        }


class CatalogServiceBase(ServiceBase):
    async def list_catalogs(
        self, list_catalogs_request: "ListCatalogsRequest"
    ) -> "ListCatalogsResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def get_metric(
        self, get_metric_request: "GetMetricRequest"
    ) -> "GetMetricResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def list_metrics(
        self, list_metrics_request: "ListMetricsRequest"
    ) -> "ListMetricsResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def get_layer(
        self, get_layer_request: "GetLayerRequest"
    ) -> "GetLayerResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def query_layer(
        self, query_layer_request: "QueryLayerRequest"
    ) -> "QueryLayerResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def __rpc_list_catalogs(
        self, stream: "grpclib.server.Stream[ListCatalogsRequest, ListCatalogsResponse]"
    ) -> None:
        request = await stream.recv_message()
        response = await self.list_catalogs(request)
        await stream.send_message(response)

    async def __rpc_get_metric(
        self, stream: "grpclib.server.Stream[GetMetricRequest, GetMetricResponse]"
    ) -> None:
        request = await stream.recv_message()
        response = await self.get_metric(request)
        await stream.send_message(response)

    async def __rpc_list_metrics(
        self, stream: "grpclib.server.Stream[ListMetricsRequest, ListMetricsResponse]"
    ) -> None:
        request = await stream.recv_message()
        response = await self.list_metrics(request)
        await stream.send_message(response)

    async def __rpc_get_layer(
        self, stream: "grpclib.server.Stream[GetLayerRequest, GetLayerResponse]"
    ) -> None:
        request = await stream.recv_message()
        response = await self.get_layer(request)
        await stream.send_message(response)

    async def __rpc_query_layer(
        self, stream: "grpclib.server.Stream[QueryLayerRequest, QueryLayerResponse]"
    ) -> None:
        request = await stream.recv_message()
        response = await self.query_layer(request)
        await stream.send_message(response)

    def __mapping__(self) -> Dict[str, grpclib.const.Handler]:
        return {
            "/unacast.catalog.v1.CatalogService/ListCatalogs": grpclib.const.Handler(
                self.__rpc_list_catalogs,
                grpclib.const.Cardinality.UNARY_UNARY,
                ListCatalogsRequest,
                ListCatalogsResponse,
            ),
            "/unacast.catalog.v1.CatalogService/GetMetric": grpclib.const.Handler(
                self.__rpc_get_metric,
                grpclib.const.Cardinality.UNARY_UNARY,
                GetMetricRequest,
                GetMetricResponse,
            ),
            "/unacast.catalog.v1.CatalogService/ListMetrics": grpclib.const.Handler(
                self.__rpc_list_metrics,
                grpclib.const.Cardinality.UNARY_UNARY,
                ListMetricsRequest,
                ListMetricsResponse,
            ),
            "/unacast.catalog.v1.CatalogService/GetLayer": grpclib.const.Handler(
                self.__rpc_get_layer,
                grpclib.const.Cardinality.UNARY_UNARY,
                GetLayerRequest,
                GetLayerResponse,
            ),
            "/unacast.catalog.v1.CatalogService/QueryLayer": grpclib.const.Handler(
                self.__rpc_query_layer,
                grpclib.const.Cardinality.UNARY_UNARY,
                QueryLayerRequest,
                QueryLayerResponse,
            ),
        }


class FileDownloadServiceBase(ServiceBase):
    async def download_metric(
        self, download_metric_request: "DownloadMetricRequest"
    ) -> "DownloadResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def __rpc_download_metric(
        self, stream: "grpclib.server.Stream[DownloadMetricRequest, DownloadResponse]"
    ) -> None:
        request = await stream.recv_message()
        response = await self.download_metric(request)
        await stream.send_message(response)

    def __mapping__(self) -> Dict[str, grpclib.const.Handler]:
        return {
            "/unacast.catalog.v1.FileDownloadService/DownloadMetric": (
                grpclib.const.Handler(
                    self.__rpc_download_metric,
                    grpclib.const.Cardinality.UNARY_UNARY,
                    DownloadMetricRequest,
                    DownloadResponse,
                )
            ),
        }
